'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

require('../assets/index.less');

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _draftJsPluginsEditor = require('draft-js-plugins-editor');

var _draftJsPluginsEditor2 = _interopRequireDefault(_draftJsPluginsEditor);

var _draftJs = require('draft-js');

var _draftJsExportHtml = require('draft-js-export-html');

var _draftJsImportHtml = require('draft-js-import-html');

var _toolbar = require('./plugins/toolbar');

var _toolbar2 = _interopRequireDefault(_toolbar);

var _index = require('./plugins/split/index');

var _index2 = _interopRequireDefault(_index);

var _index3 = require('./plugins/bold/index');

var _index4 = _interopRequireDefault(_index3);

var _index5 = require('./plugins/italic/index');

var _index6 = _interopRequireDefault(_index5);

var _index7 = require('./plugins/underline/index');

var _index8 = _interopRequireDefault(_index7);

var _index9 = require('./plugins/strikethrough/index');

var _index10 = _interopRequireDefault(_index9);

var _index11 = require('./plugins/color/index');

var _index12 = _interopRequireDefault(_index11);

var _index13 = require('./plugins/bgcolor/index');

var _index14 = _interopRequireDefault(_index13);

var _index15 = require('./plugins/font/index');

var _index16 = _interopRequireDefault(_index15);

var _index17 = require('./plugins/size/index');

var _index18 = _interopRequireDefault(_index17);

var _index19 = require('./plugins/head/index');

var _index20 = _interopRequireDefault(_index19);

var _index21 = require('./plugins/orderList/index');

var _index22 = _interopRequireDefault(_index21);

var _index23 = require('./plugins/unorderList/index');

var _index24 = _interopRequireDefault(_index23);

var _index25 = require('./plugins/link/index');

var _index26 = _interopRequireDefault(_index25);

var _index27 = require('./plugins/unlink/index');

var _index28 = _interopRequireDefault(_index27);

var _index29 = require('./plugins/image/index');

var _index30 = _interopRequireDefault(_index29);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var RcEditor = function (_Component) {
    _inherits(RcEditor, _Component);

    function RcEditor(props) {
        _classCallCheck(this, RcEditor);

        var _this = _possibleConstructorReturn(this, (RcEditor.__proto__ || Object.getPrototypeOf(RcEditor)).call(this, props));

        _this.getEditorState = function () {
            return _this.state.editorState;
        };

        var contentState = (0, _draftJsImportHtml.stateFromHTML)(props.defaultValue);
        _this.state = {
            editorState: _draftJs.EditorState.createWithContent(contentState),
            plugins: _this.props.plugins.concat(_this.props.defaultPlugins)
        };
        return _this;
    }

    _createClass(RcEditor, [{
        key: 'getPlugins',
        value: function getPlugins() {
            return this.state.plugins.slice();
        }
    }, {
        key: 'onChange',
        value: function onChange(editorState) {
            this.setState({
                editorState: editorState
            });
            this.props.onChange(editorState);
            var html = (0, _draftJsExportHtml.stateToHTML)(editorState.getCurrentContent());
            this.props.getHTML(html);
        }
    }, {
        key: 'focus',
        value: function focus() {
            this.refs.editor.focus();
        }
    }, {
        key: 'render',
        value: function render() {
            var Toolbar = _toolbar2.default.component;

            //获取当前样式和模块样式，用于标识工具栏激活状态
            var editorState = this.state.editorState;
            var currentStyle = editorState.getCurrentInlineStyle();
            var selection = editorState.getSelection();
            var blockType = editorState.getCurrentContent().getBlockForKey(selection.getStartKey()).getType();

            return _react2.default.createElement(
                'div',
                { className: this.props.prefixCls + '-root', style: { width: this.props.width } },
                _react2.default.createElement(Toolbar, {
                    prefixCls: this.props.prefixCls,
                    lang: this.props.lang,
                    setEditorState: this.onChange.bind(this),
                    getEditorState: this.getEditorState,
                    plugins: this.state.plugins,
                    toolbars: this.props.toolbars,
                    currentStyle: currentStyle,
                    blockType: blockType
                }),
                _react2.default.createElement('div', { className: 'clear' }),
                _react2.default.createElement(
                    'div',
                    { onClick: this.focus.bind(this),
                        className: this.props.prefixCls + '-editor',
                        style: { height: this.props.height, overflow: 'auto' }
                    },
                    _react2.default.createElement(_draftJsPluginsEditor2.default, {
                        editorState: this.state.editorState,
                        onChange: this.onChange.bind(this),
                        plugins: this.state.plugins,
                        ref: 'editor'
                    })
                )
            );
        }
    }]);

    return RcEditor;
}(_react.Component);

RcEditor.propTypes = {
    prefixCls: _react2.default.PropTypes.string.isRequired,
    lang: _react2.default.PropTypes.string.isRequired,
    width: _react2.default.PropTypes.string.isRequired,
    height: _react2.default.PropTypes.string.isRequired,
    plugins: _react2.default.PropTypes.array,
    toolbars: _react2.default.PropTypes.array,
    onChange: _react2.default.PropTypes.func,
    getHTML: _react2.default.PropTypes.func
};
RcEditor.defaultProps = {
    prefixCls: 'rc-editor',
    lang: 'zh-CN',
    width: '100%',
    height: '280px',
    defaultValue: '',
    plugins: [],
    defaultPlugins: [_toolbar2.default, _index4.default, _index6.default, _index8.default, _index10.default, _index12.default, _index14.default, _index2.default, _index16.default, _index18.default, _index20.default, _index22.default, _index24.default, _index26.default, _index28.default, _index30.default],
    toolbars: ['bold', 'italic', 'underline', 'strikethrough', '|', 'color', 'bgcolor', 'font', 'size', '|', 'head', 'orderlist', 'unorderlist', '|', 'link', 'unlink', 'image'],

    onChange: function onChange(editorState) {},
    getHTML: function getHTML(html) {}

};
exports.default = RcEditor;