'use strict';

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _draftJs = require('draft-js');

var _draftJsExportHtml = require('draft-js-export-html');

var _draftJsImportHtml = require('draft-js-import-html');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

module.exports = _react2.default.createClass({
    displayName: 'exports',
    getInitialState: function getInitialState() {
        return {
            value: '',
            sourceVisible: false
        };
    },
    componentWillReceiveProps: function componentWillReceiveProps(nextProps) {
        var html = (0, _draftJsExportHtml.stateToHTML)(nextProps.editorState.getCurrentContent());
        this.setState({
            value: html
        });
    },
    handleCommand: function handleCommand() {
        this.props.toggleEditor();
        this.toggleSource();
    },
    toggleSource: function toggleSource() {
        this.setState({
            sourceVisible: !this.state.sourceVisible
        });
    },
    editorSource: function editorSource(e) {
        e.stopPropagation();
        e.target.focus();
    },
    onChange: function onChange(e) {
        this.setState({
            value: e.target.value
        });
    },
    render: function render() {
        var props = this.props;

        return _react2.default.createElement(
            'div',
            { className: props.prefixCls + '-toolbar-item', title: props.title, onMouseDown: this.handleCommand },
            _react2.default.createElement('i', { className: 'toolbar-item-icon-code icon ' }),
            _react2.default.createElement('textarea', {
                className: props.prefixCls + '-source',
                value: this.state.value,
                onMouseDown: this.editorSource,
                style: this.state.sourceVisible ? {} : { display: 'none' },
                onChange: this.onChange
            })
        );
    }
});