'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.colorArr = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _draftJs = require('draft-js');

var _Menu = require('../../../Menu');

var _Menu2 = _interopRequireDefault(_Menu);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var colorArr = ['E53333', 'E56600', 'FF9900', '64451D', 'DFC5A4', 'FFE500', '009900', '006600', '99BB00', 'B8D100', '60D978', '00D5FF', '337FE5', '003399', '4C33E5', '9933E5', 'CC33E5', 'EE33EE', 'FFFFFF', 'CCCCCC', '999999', '666666', '333333', '000000'];

var Color = function (_React$Component) {
    _inherits(Color, _React$Component);

    function Color() {
        _classCallCheck(this, Color);

        return _possibleConstructorReturn(this, (Color.__proto__ || Object.getPrototypeOf(Color)).apply(this, arguments));
    }

    _createClass(Color, [{
        key: 'handleCommand',
        value: function handleCommand(e) {
            var inlineStyle = e.currentTarget.getAttribute('data-inlineStyle');
            this.props.setEditorState(_draftJs.RichUtils.toggleInlineStyle(this.props.getEditorState(), inlineStyle));
        }
    }, {
        key: 'render',
        value: function render() {
            var _this2 = this;

            var props = this.props;

            var list = colorArr.map(function (item, i) {
                return _react2.default.createElement(
                    'div',
                    { className: props.prefixCls + '-menu-item',
                        key: i,
                        'data-inlineStyle': _this2.props.type + '-' + item,
                        onMouseDown: _this2.handleCommand.bind(_this2) },
                    _react2.default.createElement('a', { style: { background: '#' + item }, title: '#' + item })
                );
            });

            //激活状态
            var active = false;
            var _iteratorNormalCompletion = true;
            var _didIteratorError = false;
            var _iteratorError = undefined;

            try {
                for (var _iterator = colorArr[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                    var item = _step.value;

                    if (props.currentStyle.has(this.props.type + '-' + item)) {
                        active = true;
                        break;
                    }
                }
            } catch (err) {
                _didIteratorError = true;
                _iteratorError = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion && _iterator.return) {
                        _iterator.return();
                    }
                } finally {
                    if (_didIteratorError) {
                        throw _iteratorError;
                    }
                }
            }

            return _react2.default.createElement(
                'div',
                { className: props.prefixCls + '-toolbar-item', title: props.title },
                _react2.default.createElement('i', { className: 'toolbar-item-icon-' + this.props.type.toLowerCase() + ' icon ' + (active ? 'active' : '') }),
                _react2.default.createElement(
                    'div',
                    { className: props.prefixCls + '-menu-color-panel' },
                    _react2.default.createElement(
                        _Menu2.default,
                        _extends({}, props, { visible: props.menuVisible }),
                        list,
                        _react2.default.createElement('div', { className: 'clear' })
                    )
                )
            );
        }
    }]);

    return Color;
}(_react2.default.Component);

Color.defaultProps = {
    type: 'COLOR'
};
exports.default = Color;
exports.colorArr = colorArr;