'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _draftJs = require('draft-js');

var _Menu = require('../../Menu');

var _Menu2 = _interopRequireDefault(_Menu);

var _MenuEnhance = require('../../MenuEnhance');

var _MenuEnhance2 = _interopRequireDefault(_MenuEnhance);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Font = function (_React$Component) {
    _inherits(Font, _React$Component);

    function Font() {
        _classCallCheck(this, Font);

        return _possibleConstructorReturn(this, (Font.__proto__ || Object.getPrototypeOf(Font)).apply(this, arguments));
    }

    _createClass(Font, [{
        key: 'handleCommand',
        value: function handleCommand(e) {
            var inlineStyle = e.currentTarget.getAttribute('data-inlineStyle');
            this.props.setEditorState(_draftJs.RichUtils.toggleInlineStyle(this.props.getEditorState(), inlineStyle));
        }
    }, {
        key: 'render',
        value: function render() {
            var _this2 = this;

            var props = this.props;
            var itemArr = [{ style: 'FONT-SONG', label: '宋体' }, { style: 'FONT-HEI', label: '黑体' }, { style: 'FONT-KAI', label: '楷体' }, { style: 'FONT-YAHEI', label: '微软雅黑' }, { style: 'FONT-ARIAL', label: 'Arial' }];
            var list = itemArr.map(function (item, i) {
                return _react2.default.createElement(
                    'div',
                    { className: props.prefixCls + '-menu-item', key: i, 'data-inlineStyle': item.style, onMouseDown: _this2.handleCommand.bind(_this2) },
                    _react2.default.createElement(
                        'a',
                        { style: { fontFamily: item.label }, title: item.label },
                        item.label
                    )
                );
            });

            //激活状态
            var active = false;
            var _iteratorNormalCompletion = true;
            var _didIteratorError = false;
            var _iteratorError = undefined;

            try {
                for (var _iterator = itemArr[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                    var item = _step.value;

                    if (props.currentStyle.has(item.style)) {
                        active = true;
                        break;
                    }
                }
            } catch (err) {
                _didIteratorError = true;
                _iteratorError = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion && _iterator.return) {
                        _iterator.return();
                    }
                } finally {
                    if (_didIteratorError) {
                        throw _iteratorError;
                    }
                }
            }

            return _react2.default.createElement(
                'div',
                { className: props.prefixCls + '-toolbar-item', title: props.title },
                _react2.default.createElement('i', { className: 'toolbar-item-icon-font icon  ' + (active ? 'active' : '') }),
                _react2.default.createElement(
                    _Menu2.default,
                    _extends({}, props, { visible: this.props.menuVisible }),
                    list
                )
            );
        }
    }]);

    return Font;
}(_react2.default.Component);

var styleMap = {
    'FONT-SONG': {
        'fontFamily': '宋体'
    },
    'FONT-HEI': {
        'fontFamily': '黑体'
    },
    'FONT-KAI': {
        'fontFamily': '楷体'
    },
    'FONT-YAHEI': {
        'fontFamily': '微软雅黑'
    },
    'FONT-Arial': {
        'fontFamily': 'Arial'
    }
};

exports.default = {
    name: 'font',
    component: (0, _MenuEnhance2.default)(Font),
    customStyleMap: styleMap
};