'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _draftJs = require('draft-js');

var _Menu = require('../../Menu');

var _Menu2 = _interopRequireDefault(_Menu);

var _MenuEnhance = require('../../MenuEnhance');

var _MenuEnhance2 = _interopRequireDefault(_MenuEnhance);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Head = function (_React$Component) {
    _inherits(Head, _React$Component);

    function Head() {
        _classCallCheck(this, Head);

        return _possibleConstructorReturn(this, (Head.__proto__ || Object.getPrototypeOf(Head)).apply(this, arguments));
    }

    _createClass(Head, [{
        key: 'handleCommand',
        value: function handleCommand(e) {
            var blockType = e.currentTarget.getAttribute('data-blockType');
            this.props.setEditorState(_draftJs.RichUtils.toggleBlockType(this.props.getEditorState(), blockType));
        }
    }, {
        key: 'render',
        value: function render() {
            var _this2 = this;

            var props = this.props;
            var itemArr = [{ blockType: 'header-one', label: "<h1>标题1</h1>" }, { blockType: 'header-two', label: "<h2>标题2</h2>" }, { blockType: 'header-three', label: "<h3>标题3</h3>" }, { blockType: 'header-four', label: "<h4>标题4</h4>" }];
            var list = itemArr.map(function (item, i) {
                return _react2.default.createElement('div', {
                    className: props.prefixCls + '-menu-item',
                    key: i,
                    'data-blockType': item.blockType,
                    onMouseDown: _this2.handleCommand.bind(_this2),
                    dangerouslySetInnerHTML: { __html: item.label }
                });
            });

            //激活状态
            var active = false;
            var _iteratorNormalCompletion = true;
            var _didIteratorError = false;
            var _iteratorError = undefined;

            try {
                for (var _iterator = itemArr[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                    var item = _step.value;

                    if (props.blockType == item.blockType) {
                        active = true;
                        break;
                    }
                }
            } catch (err) {
                _didIteratorError = true;
                _iteratorError = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion && _iterator.return) {
                        _iterator.return();
                    }
                } finally {
                    if (_didIteratorError) {
                        throw _iteratorError;
                    }
                }
            }

            return _react2.default.createElement(
                'div',
                { className: props.prefixCls + '-toolbar-item', title: props.title },
                _react2.default.createElement('i', { className: 'toolbar-item-icon-header icon ' + (active ? 'active' : '') }),
                _react2.default.createElement(
                    _Menu2.default,
                    _extends({}, props, { visible: this.props.menuVisible }),
                    list
                )
            );
        }
    }]);

    return Head;
}(_react2.default.Component);

exports.default = {
    name: 'head',
    component: (0, _MenuEnhance2.default)(Head)
};