'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _draftJs = require('draft-js');

var _MenuEnhance = require('../../MenuEnhance');

var _MenuEnhance2 = _interopRequireDefault(_MenuEnhance);

var _Media = require('./components/Media');

var _Media2 = _interopRequireDefault(_Media);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Image = function Image(props) {
    var entity = _draftJs.Entity.get(props.block.getEntityAt(0));

    var _entity$getData = entity.getData();

    var src = _entity$getData.src;

    return _react2.default.createElement('img', { src: src });
};

function blockRendererFn(block) {
    if (block.getType() === 'atomic') {
        return {
            component: Image,
            editable: true
        };
    }
    return null;
}

exports.default = {
    name: 'image',
    component: (0, _MenuEnhance2.default)(_Media2.default),
    blockRendererFn: blockRendererFn
};