'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _draftJs = require('draft-js');

var _Menu = require('../../Menu');

var _Menu2 = _interopRequireDefault(_Menu);

var _MenuEnhance = require('../../MenuEnhance');

var _MenuEnhance2 = _interopRequireDefault(_MenuEnhance);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Link = function (_React$Component) {
    _inherits(Link, _React$Component);

    function Link() {
        _classCallCheck(this, Link);

        return _possibleConstructorReturn(this, (Link.__proto__ || Object.getPrototypeOf(Link)).apply(this, arguments));
    }

    _createClass(Link, [{
        key: 'addLink',
        value: function addLink() {
            var url = this.refs.urlInput.value;
            var editorState = this.props.getEditorState();
            var entityKey = null;
            if (url) {
                entityKey = _draftJs.Entity.create('LINK', 'MUTABLE', { url: url });
            }
            var netEditorState = _draftJs.RichUtils.toggleLink(editorState, editorState.getSelection(), entityKey);
            this.props.setEditorState(netEditorState);
        }
    }, {
        key: 'handlefocus',
        value: function handlefocus(e) {
            e.preventDefault();
            e.stopPropagation();
            this.refs.urlInput.focus();
        }
    }, {
        key: 'render',
        value: function render() {
            var props = this.props;

            return _react2.default.createElement(
                'div',
                { className: props.prefixCls + '-toolbar-item', title: props.title },
                _react2.default.createElement('i', { className: 'toolbar-item-icon-link icon ' }),
                _react2.default.createElement(
                    'div',
                    { className: this.props.prefixCls + '-menu-link-panel' },
                    _react2.default.createElement(
                        _Menu2.default,
                        _extends({}, props, { visible: this.props.menuVisible }),
                        _react2.default.createElement(
                            'div',
                            { className: props.prefixCls + '-menu-link-input' },
                            _react2.default.createElement('input', { type: 'text', defaultValue: 'http://', ref: 'urlInput', onMouseDown: this.handlefocus.bind(this) })
                        ),
                        _react2.default.createElement(
                            'div',
                            { className: props.prefixCls + '-menu-link-button' },
                            _react2.default.createElement(
                                'button',
                                { onMouseDown: this.addLink.bind(this) },
                                '确定'
                            ),
                            _react2.default.createElement(
                                'button',
                                null,
                                '取消'
                            ),
                            _react2.default.createElement('div', { className: 'clear' })
                        )
                    )
                )
            );
        }
    }]);

    return Link;
}(_react2.default.Component);

;

function linkStrategy(contentBlock, callback) {
    contentBlock.findEntityRanges(function (character) {
        var entityKey = character.getEntity();
        return entityKey !== null && _draftJs.Entity.get(entityKey).getType() === 'LINK';
    }, callback);
}
var DecoratorLink = function DecoratorLink(props) {
    var _Entity$get$getData = _draftJs.Entity.get(props.entityKey).getData();

    var url = _Entity$get$getData.url;

    return _react2.default.createElement(
        'a',
        { href: url },
        props.children
    );
};

exports.default = {
    name: 'link',
    component: (0, _MenuEnhance2.default)(Link),
    decorators: [{
        strategy: linkStrategy,
        component: DecoratorLink
    }]
};