'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _draftJs = require('draft-js');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Underline = function Underline(props) {
    function handleCommand() {
        props.setEditorState(_draftJs.RichUtils.toggleInlineStyle(props.getEditorState(), 'STRIKETHROUGH'));
    }
    var active = props.currentStyle.has('STRIKETHROUGH');
    return _react2.default.createElement(
        'div',
        { className: props.prefixCls + '-toolbar-item', title: props.title, onMouseDown: handleCommand },
        _react2.default.createElement('i', { className: 'toolbar-item-icon-strikethrough icon ' + (active ? 'active' : '') })
    );
};

exports.default = {
    name: 'strikethrough',
    component: Underline
};