'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _draftJs = require('draft-js');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Unlink = function Unlink(props) {
    function handleCommand() {
        var editorState = props.getEditorState();
        var entityKey = null;
        var newEditorState = _draftJs.RichUtils.toggleLink(editorState, editorState.getSelection(), entityKey);
        props.setEditorState(newEditorState);
    }
    return _react2.default.createElement(
        'div',
        { className: props.prefixCls + '-toolbar-item', title: props.title, onMouseDown: handleCommand.bind(undefined) },
        _react2.default.createElement('i', { className: 'toolbar-item-icon-unlink icon ' })
    );
};

exports.default = {
    name: 'unlink',
    component: Unlink
};